//+------------------------------------------------------------------+
//|                                                        tick data |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_chart_window

#include <WinUser32.mqh>
#import "user32.dll"
      int RegisterWindowMessageA(string aString);
      int GetParent(int hWnd);
#import

//
//
//
//
//

extern int  TicksPerBar  = 10;
extern int  DisplayDelay = 0;
extern bool ResetData    = false;
extern bool ShowComment  = false;
extern bool TestMode     = false;

//
//
//
//
//

int      fileHandle = -1;
int      filePeriod =  1;
string   fileSymbol;

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   TicksPerBar = MathMax(MathMin(TicksPerBar,9999),1);
   fileSymbol  = "_t"+Symbol();
   filePeriod  = TicksPerBar;
   return (0);
}

//
//
//
//
//

void deinit()
{
   if (fileHandle >= 0) { FileClose(fileHandle); fileHandle = -1; }
   if (ShowComment) Comment("");
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int OpenHistoryFile()
{
   string name = fileSymbol+filePeriod;
      if (ResetData)
          fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE);
      if (fileHandle >= 0) FileClose(fileHandle);
          fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE|FILE_READ);

      //
      //
      //
      //
      //
       
      if (fileHandle >=0)
      {
         if (FileSize(fileHandle)<148) WriteHistoryHeader();
         return(0);
      }
      else return(-1);
}

//
//
//
//
//

int WriteHistoryHeader()
{
   string c_copyright  = "(C)opyright 2003, MetaQuotes Software Corp.";
   int    digits       = Digits;
   int    version      = 400;   
   int    unused[13];

   if (fileHandle >= 0)
   {
      FileWriteInteger(fileHandle, version, LONG_VALUE);
      FileWriteString(fileHandle, c_copyright, 64);
      FileWriteString(fileHandle, fileSymbol , 12);
      FileWriteInteger(fileHandle, filePeriod, LONG_VALUE);
      FileWriteInteger(fileHandle, digits    , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);  // last synchronization
      FileWriteArray(fileHandle, unused,0,13);
              FileFlush(fileHandle);
   }
   return (0);
}

//
//
//
//
//

#define recordSize 44
void WriteHistoryData(int time, double bidPrice, double askPrice)
{
   if (fileHandle >= 0)
   {
      bool found = FileSeek(fileHandle,0,SEEK_END);
   
      //
      //
      //
      //
      //
      
      if (TicksPerBar==1)
         {
            int      tT = time;     // time of the bar
            double   tO = askPrice; // tick open
            double   tL = bidPrice; // tick low
            double   tH = askPrice; // tick high
            double   tC = bidPrice; // tick close
            double   tV = 1;
         }
      else
         {               
            if (found)
            {
               int size = FileTell(fileHandle);
               if (size>=192)
               {
                   found = FileSeek(fileHandle,size-recordSize,SEEK_SET);
                           tT = FileReadInteger(fileHandle,LONG_VALUE);
                           tO = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tL = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tH = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tC = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tV = FileReadDouble(fileHandle,DOUBLE_VALUE);
                   if (tV<TicksPerBar)                           
                        found = FileSeek(fileHandle,size-recordSize,SEEK_SET);
                   else found = FileSeek(fileHandle,0              ,SEEK_END);
               }
               else tV = TicksPerBar;
               
               //
               //
               //
               //
               //
                  
               if  (tV >= TicksPerBar)
                  {
                        tT = time;
                        tO = bidPrice;
                        tL = bidPrice;
                        tH = bidPrice;
                        tC = bidPrice;
                        tV = 1;
                  }
               else                     
                  {
                     tV    = tV+1;
                     tH    = MathMax(tH,bidPrice);
                     tL    = MathMin(tL,bidPrice);
                     tC    = bidPrice;
                  }
            }
         }

      //
      //
      //
      //
      //
         
         if (found)
         {
            FileWriteInteger(fileHandle, tT, LONG_VALUE);   //    time
            FileWriteDouble(fileHandle, tO, DOUBLE_VALUE);  //    open
            FileWriteDouble(fileHandle, tL, DOUBLE_VALUE);  //    low
            FileWriteDouble(fileHandle, tH, DOUBLE_VALUE);  //    high
            FileWriteDouble(fileHandle, tC, DOUBLE_VALUE);  //    close
            FileWriteDouble(fileHandle, tV, DOUBLE_VALUE);  //    volume
 
            //
            //
            //    update time of last synchronization
            //
            //
        
            FileSeek(fileHandle,92,SEEK_SET);
            FileWriteInteger(fileHandle,time,LONG_VALUE);
                   FileFlush(fileHandle);
         
         //
         //
         //
         //
         //
         
         if (ShowComment) Comment("tick saved at : "+TimeToStr(TimeLocal(),TIME_SECONDS));
      }
   }
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

#define CHART_CMD_UPDATE_DATA 33324

//
//
//
//
//

void UpdateChartWindows()
{
   if (fileHandle < 0) return;

   //
   //
   //
   //
   //

      static datetime lastRefresh   = 0; 
               string chartName     = fileSymbol+",M"+filePeriod+" (offline)";
               string stringForName = "                                                                                "; 
               if ((TimeLocal()-lastRefresh)<DisplayDelay) return;
                                lastRefresh=TimeLocal();
               
      //
      //
      //
      //
      //

      int windowHandle = WindowHandle(fileSymbol,filePeriod);
      if (windowHandle != 0)
      {
         windowHandle = GetParent(windowHandle);
         windowHandle = GetWindow(windowHandle,GW_HWNDFIRST);
         while (windowHandle != 0)
         {
            int len = GetWindowTextA(windowHandle,stringForName,80);
            if (len > 0 && StringSubstr(stringForName,0,len) == chartName)
                        PostMessageA(windowHandle,WM_COMMAND,CHART_CMD_UPDATE_DATA,0);
            windowHandle = GetWindow(windowHandle,GW_HWNDNEXT);
         }
      }
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   static string accountCompany = "";
      if (AccountCompany() != accountCompany)
      if (fileHandle>=0) 
         {
            FileClose(fileHandle); fileHandle=-1;
            accountCompany = AccountCompany();
         }
                        
   //
   //
   //
   //
   //            
                     
      if (fileHandle<0) OpenHistoryFile();
      if (fileHandle<0) return(0);
      if (TestMode)
         WriteHistoryData(Time[0],Close[0],Close[0]);
      else
         {
            WriteHistoryData(TimeCurrent(),Bid,Ask);
            UpdateChartWindows();
         }               
}